=== debian/changelog ===
nxtvepg (0.7.0) unstable; urgency=low

  * new upstream release (closes: #138775).
  * spell fix (closes: #125196).

 -- Gerd Knorr <kraxel@debian.org>  Tue,  9 Apr 2002 16:53:10 +0200

nxtvepg (0.6.4-1.1) unstable; urgency=low

  * Non-Maintainer Upload
  * Remove -O3 flag on hppa, to allow building.  (Closes: #126573)

 -- David Schleef <ds@schleef.org>  Sun, 17 Feb 2002 01:50:36 -0800

nxtvepg (0.6.4-1) unstable; urgency=low

  * new upstream release (closes: #120248,#121615).

 -- Gerd Knorr <kraxel@debian.org>  Wed, 12 Dec 2001 18:31:00 +0100

nxtvepg (0.5.2-2) unstable; urgency=low

  * added xutils (mkdirhier) to build dependences (closes: #107755).

 -- Gerd Knorr <kraxel@debian.org>  Mon,  6 Aug 2001 12:13:21 +0200

nxtvepg (0.5.2-1) unstable; urgency=low

  * Initial Release.

 -- Gerd Knorr <kraxel@debian.org>  Sun, 11 Feb 2001 18:03:35 +0100

Local variables:
mode: debian-changelog
End:
