=== debian/control ===
Source: nxtvepg
Section: utils
Priority: extra
Build-Depends: debhelper (>=2), tk8.3-dev, tcl8.3-dev, xutils
Maintainer: Gerd Knorr <kraxel@debian.org>
Standards-Version: 3.5.2

Package: nxtvepg
Architecture: any
Depends: ${shlibs:Depends}
Description: Nextview EPG decoder and browser
 In this software package you find a decoder for Nextview - an Electronic
 TV Programme Guide for the analog domain (as opposed to the various digital
 EPGs that come with most digital broadcasts). It allows you to decode and
 browse TV programme listings for most of the major networks in Germany,
 Austria, France and Switzerland.
 .
 Currently Nextview EPG is transmitted by:
  - in Germany and Austria: Pro7, 3Sat, RTL-II.
  - in Switzerland: EuroNews, SF1, TSR1.
  - in France: Canal+, M6, TV5.
  - in Turkey: TRT (as of June/2001 still a test transmission)
 .
 The EPG information is read from /dev/vbi, i.e. you need some TV card
 which provides a VBI data stream.  bttv cards work.  zoran might work
 too, but I haven't tested that due to lack of hardware...
