## nxtvepg 2.7.5

=== Makefile ===
--- 
+++ 
@@ -28,7 +28,7 @@
 #
 #  Author: Tom Zoerner
 #
-#  $Id: Makefile,v 1.76 2004/07/18 12:58:31 tom Exp tom $
+#  $Id: Makefile,v 1.77.1.1 2005/03/30 15:48:11 tom Exp $
 #
 
 ifeq ($(OS),Windows_NT)
@@ -93,7 +93,7 @@
 # (note proxy API is still subject to change as of March-2004)
 #DEFS   += -DUSE_VBI_PROXY
 #LDLIBS += -lzvbi -lpthread -lpng
-#LDLIBS += /tom/work/tv/cvs/vbi/src/.libs/libzvbi.a -lpthread -lpng
+#LDLIBS += /tom/work/tv/cvs/x-ssh/vbi/src/.libs/libzvbi.a -lpthread -lpng
 
 # enable workarounds for linux saa7134 driver: up to version 0.2.6
 # - change VBI default sampling rate (because the driver doesn't support ioctl VIDIOCGVBIFMT)
@@ -159,7 +159,7 @@
 VBIREC_CSRC2  = epgvbi/btdrv4linux epgvbi/vbidecode epgvbi/zvbidecoder \
                 epgvbi/ttxdecode epgvbi/hamming epgvbi/cni_tables \
                 epgvbi/syserrmsg epgctl/debug epgui/xawtv
-VBIREC_TCLSRC = tvsim/vbirec_gui
+VBIREC_TCLSRC = tvsim/vbirec_gui epgtcl/combobox
 
 NXTV_OBJS     = $(addprefix $(BUILD_DIR)/, $(addsuffix .o, $(CSRC) $(TCLSRC)))
 TVSIM_OBJS    = $(addprefix $(BUILD_DIR)/, $(addsuffix .o, $(TVSIM_CSRC) $(TVSIM_CSRC2) $(TVSIM_TCLSRC)))
@@ -259,7 +259,6 @@
 clean:
 	-rm -rf build-*
 	-rm -f core a.out *.exe *.o
-	-rm -f epgui/tkwinico.res
 
 .PHONY: depend
 depend:
@@ -282,11 +281,11 @@
 	  EPG_VERSION_STR=`egrep '[ \t]*#[ \t]*define[ \t]*EPG_VERSION_STR' epgctl/epgversion.h | head -1 | sed -e 's#.*"\(.*\)".*#\1#'`; \
 	  echo "pod2man nxtvepg.pod > nxtvepg.1"; \
 	  pod2man -date " " -center "Nextview EPG Decoder" -section "1" \
-	          -release "nxtvepg "$$EPG_VERSION_STR" (C) 1999-2004 Tom Zoerner" \
+	          -release "nxtvepg "$$EPG_VERSION_STR" (C) 1999-2005 Tom Zoerner" \
 	     nxtvepg.pod > nxtvepg.1; \
 	  echo "pod2html nxtvepg.pod > manual.html"; \
 	  pod2html nxtvepg.pod | $(PERL) -p -e 's/(HREF=\"#)([^:"]+: |[^_"]+(_[^_"]+)?__)+/$$1/gi;' > manual.html; \
-	  rm -f pod2htm?.x~~ pod2html-{dircache,itemcache}; \
+	  rm -f pod2htm?.* pod2html-{dircache,itemcache}; \
 	else \
 	  echo "ERROR: cannot generate manual page without Perl"; \
 	  false; \
@@ -297,11 +296,11 @@
 	  TVSIM_VERSION_STR=`egrep '[ \t]*#[ \t]*define[ \t]*TVSIM_VERSION_STR' tvsim/tvsim_version.h | head -1 | sed -e 's#.*"\(.*\)".*#\1#'`; \
 	  echo "pod2man tvsim/tvsim.pod > tvsim/tvsim.1"; \
 	  pod2man -date " " -center "TV app interaction simulator" -section "1" \
-	          -release "tvsim "$$TVSIM_VERSION_STR" (C) 2002,2004 Tom Zoerner" \
+	          -release "tvsim "$$TVSIM_VERSION_STR" (C) 2002,2004,2005 Tom Zoerner" \
 	          tvsim/tvsim.pod > tvsim/tvsim.1; \
 	  echo "pod2html tvsim/tvsim.pod > tvsim/tvsim.html"; \
 	  pod2html tvsim/tvsim.pod | $(PERL) -p -e 's/(HREF=\"#)([^:"]+: |[^_"]+(_[^_"]+)?__)+/$$1/gi;' > tvsim/tvsim.html; \
-	  rm -f pod2htm?.x~~ pod2html-{dircache,itemcache}; \
+	  rm -f pod2htm?.* pod2html-{dircache,itemcache}; \
 	else \
 	  echo "ERROR: cannot generate tvsim HTML or nroff manuals without Perl"; \
 	  false; \
